#CMFBlogger licensed under ZPL 
#NOTE: current bug requires USERNAME to be Manager ;(
from testClient import invokeClient

USERNAME='nathan'
PASSWORD='nathan'
URL='http://localhost:8080/collective/portal_weblog'
APPKEY='blogtest'
CONTENT="""\
This is some test content.  We could use lorem ipsum but that would require a googling. 
I can't believe I'm writing unit tests for a freakin BloggerTool.  What overkill.
"""
BLOGID='home'

def testUserInfo(client):
    assert client.portal_weblog.blogger.getUserInfo(APPKEY,USERNAME,PASSWORD), 'Could not return information using login:%s and password:%s' % (USERNAME, PASSWORD)

def testNewPost(client):
    assert client.portal_weblog.blogger.newPost(APPKEY, BLOGID,USERNAME,PASSWORD,CONTENT,0), 'Could not post new content'

def testEditPost(client):
    postings=client.portal_weblog.blogger.getRecentPosts(APPKEY, BLOGID,USERNAME,PASSWORD)
    if len(postings):
        result=postings[0]
        new_content=''.join(result['content'].split(' '))
        client.portal_weblog.blogger.editPost(APPKEY, result['postid'],USERNAME,PASSWORD, new_content, 0)
    postings=client.portal_weblog.blogger.getRecentPosts(APPKEY, BLOGID, USERNAME,PASSWORD)
    if len(postings):
        result=postings[0]
        new_content=''.join(CONTENT.split(' '))
        assert result['content']==new_content, 'The text of the Posting is incorrect'
    
def testDeletePost(client):
    postings=client.portal_weblog.blogger.getRecentPosts(APPKEY, BLOGID,USERNAME,PASSWORD)
    if len(postings):
        result=postings[0]
        assert client.portal_weblog.blogger.deletePost(APPKEY, result['postid'],USERNAME,PASSWORD, 0), 'Deleting Blog Entry, ' + resulti['postid'] + ' failed.'

def testListPostings(client):
    assert len(client.portal_weblog.blogger.getRecentPosts(APPKEY, BLOGID, USERNAME,PASSWORD)), 'Could not get list Blog Entries'
    
def testGetUsersBlogs(client):
    assert len(client.portal_weblog.blogger.getUsersBlogs(APPKEY,USERNAME,PASSWORD)), 'Could not get Users Blogs'

if __name__=='__main__':
    import xmlrpclib
    xmlrpcClient=xmlrpclib.Server(URL)
    #xmlrpcClient=invokeClient(login=USERNAME, password=PASSWORD, url=URL)
    testUserInfo(xmlrpcClient)
    testNewPost(xmlrpcClient)
    testEditPost(xmlrpcClient)
    testListPostings(xmlrpcClient)
    testDeletePost(xmlrpcClient)
    testGetUsersBlogs(xmlrpcClient)

